/* 		

if(g_Accept[id] == 0)
	else
	ColorChat(id,GREEN,"%s %L",g_Prefix,LANG_PLAYER,"g_Accept")	

*/

#include <amxmodx>
#include <sqlx>
#include <colorchat>

#define PLUGIN "Auto Steam Invite"
#define VERSION "1.0"
#define AUTHOR "speedkill & benio101"

new const g_Langcmd[][] = { "say /dolacz","say /join" }

new g_Prefix[64]
new g_Group[64]
new bool:g_Steam[33]
new bool:g_Have[33]
new g_SteamID[33][64]
new g_Accept[33]

new Handle:g_SqlTuple

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_logevent("new_round", 2, "1=Round_Start")
	
	for(new i;i<sizeof g_Langcmd;i++)
	{
		register_clcmd(g_Langcmd[i], "ask")
	}
}
public plugin_cfg()
{
	register_dictionary("steam_autoinvite.txt")
	
	register_cvar("steam_autoinvite_prefix","[Steam Invite]")
	register_cvar("steam_autoinvite_group","Testowa Grupa")
	
	register_cvar("steam_autoinvite_host", "localhost")
	register_cvar("steam_autoinvite_user", "root")
	register_cvar("steam_autoinvite_pass", "root")
	register_cvar("steam_autoinvite_db", "db")
	
	sql_connect()
	
	get_cvar_string("steam_autoinvite_prefix",g_Prefix,charsmax(g_Prefix))
	get_cvar_string("steam_autoinvite_group",g_Group,charsmax(g_Group))
}
public sql_connect()
{
	new Host[32], User[32], Pass[32], DB[32]
	
	get_cvar_string("steam_autoinvite_host", Host, charsmax(Host))
	get_cvar_string("steam_autoinvite_user", User, charsmax(User))
	get_cvar_string("steam_autoinvite_pass", Pass,charsmax(Pass))
	get_cvar_string("steam_autoinvite_db", DB, charsmax(DB))
	
	g_SqlTuple = SQL_MakeDbTuple(Host,User,Pass,DB)
	
	new error, szError[128]
	new Handle:hConn = SQL_Connect(g_SqlTuple,error,szError, 127)
	if(error)
	{
		log_amx("Error: %s", szError)
		return
	}
	
	new Handle:Queries = SQL_PrepareQuery(hConn,"CREATE TABLE IF NOT EXISTS `Steam`(steam_id VARCHAR(32) NOT NULL, unix_time INT(10) NOT NULL DEFAULT 0, flag INT(1) NOT NULL DEFAULT 0, accept INT(1) NOT NULL DEFAULT 0, PRIMARY KEY(steam_id))")
	
	SQL_Execute(Queries)
	SQL_FreeHandle(Queries)
	SQL_FreeHandle(hConn)
}
public plugin_end()
{
	SQL_FreeHandle(g_SqlTuple)
}
public new_round()
{
	for(new id=1;id<33;id++)
	{
		if(is_user_connected(id))
		{
			if(!g_Have[id])
			{
				g_Have[id] = true
				menu(id)
			}
		}
	}
}			
public client_authorized(id)
{
	if(is_user_steam(id))
	{
		g_Steam[id] = true
		get_user_authid(id, g_SteamID[id], charsmax(g_SteamID[]))
		sql_load(id)
	}
}
public client_disconnect(id)
{
	g_Have[id] = false
	g_Steam[id] = false
	g_Accept[id] = 0	
}
public ask(id)
{
	if(is_user_connected(id))
	{
		if(g_Steam[id])
			menu(id)
		else
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Ns")
	}
}
public menu(id)
{
	new title[128]
	formatex(title,charsmax(title),"\w%L %s",LANG_PLAYER,"g_Ask",g_Group)
	new menu = menu_create(title, "choosing")
	
	new g_Name[2][8]
	
	formatex(g_Name[0],charsmax(g_Name[]),"\r%L",LANG_PLAYER,"g_Yes")
	formatex(g_Name[1],charsmax(g_Name[]),"\y%L",LANG_PLAYER,"g_No")
	
	menu_additem(menu,g_Name[0])
	menu_additem(menu,g_Name[1])
	
	menu_display(id, menu, 0)
}
public choosing(id, menu, item)
{
	switch(item)
	{
		case 0:
		{
			g_Accept[id] = 1
			sql_save(id)
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Smi")
		}
		case 1:
		{
			g_Accept[id] = 0
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Dw")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public sql_save(id)
{
	new szTemp[512]
	formatex(szTemp,charsmax(szTemp),"UPDATE `Steam` SET `unix_time` = '%d',`flag` = '%d',`accept` = '%d' WHERE `steam_id` = '%s'",get_systime(),g_Accept[id],g_Accept[id],g_SteamID[id])
	SQL_ThreadQuery(g_SqlTuple,"IgnoreHandle",szTemp)
}
public sql_load(id)
{
	new szTemp[512],data[1]
	data[0] = id
	formatex(szTemp,charsmax(szTemp),"SELECT * FROM `Steam` WHERE `steam_id` = '%s'",g_SteamID[id])
	SQL_ThreadQuery(g_SqlTuple,"check",szTemp, data, sizeof(data))
}

public check(failstate, Handle:query, error[],errcode, data[], datasize)
{
	if(failstate != TQUERY_SUCCESS)
	{
		log_amx("<Query> Error: %s", error)
		return
	}
	new id = data[0]
	if(!is_user_connected(id) && !is_user_connecting(id))
		return
	
	if(SQL_NumRows(query))
	{
		g_Accept[id] = SQL_ReadResult(query, SQL_FieldNameToNum(query,"accept"))
		if(g_Accept[id] == 1)
			g_Have[id] = true
	} 
	else
	{
		new szTemp[512]
		formatex(szTemp,charsmax(szTemp),"INSERT INTO `Steam` (`steam_id`) VALUES ('%s')",g_SteamID[id])
		SQL_ThreadQuery(g_SqlTuple, "IgnoreHandle", szTemp)
		g_Have[id] = false
	}
}
public IgnoreHandle(failstate, Handle:query, error[], errnum)
{
	if(failstate != TQUERY_SUCCESS)
	{
		log_amx("<Query> Error: %s", error)
		return
	}
}
stock is_user_steam(id)
{
	if(!is_user_bot(id) && !is_user_hltv(id))
	{
		new steam[33]
		get_user_authid(id,steam,charsmax(steam))
		return bool:(contain(steam,"STEAM_0:0:") != -1 || contain(steam, "STEAM_0:1:") != -1)
	}
	return false
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
