#include <amxmisc>
#include <orpheu>
#include <orpheu_stocks>

#define PLUGIN "AMXX.PL"
#define VERSION "1.0"
#define AUTHOR "DarkGL"

new bool:catch = false;
new gId;
new bool:stop = false;
new Tmp[256];
new g_max_player;
new iMessage;
new iDestType; 
new bool:copied = false;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	new OrpheuFunction:WriteString = OrpheuGetEngineFunction("pfnWriteString","WriteString")
	new OrpheuFunction:MessageBegin = OrpheuGetEngineFunction("pfnMessageBegin","MessageBegin")
	new OrpheuFunction:MessageEnd = OrpheuGetEngineFunction("pfnMessageEnd","MessageEnd")
	new OrpheuFunction:WriteByte = OrpheuGetEngineFunction("pfnWriteByte","WriteByte")
	
	OrpheuRegisterHook(WriteString,"WriteStringf",OrpheuHookPre)
	OrpheuRegisterHook(MessageBegin,"MessageBeginf",OrpheuHookPre)
	OrpheuRegisterHook(MessageEnd,"MessageEndf",OrpheuHookPost)
	OrpheuRegisterHook(WriteByte,"WriteBytef",OrpheuHookPre)
	
	g_max_player = get_maxplayers();
}

public OrpheuHookReturn:WriteBytef(iValue){
	iDestType = iValue;
	if(catch && stop){
		return OrpheuSupercede;
	}
	return OrpheuIgnored;
}

public OrpheuHookReturn:WriteStringf(szStr[])
{
	if(catch){
		if(stop && !copied){
			copied = true;
			copy(Tmp,charsmax(Tmp),szStr)
			return OrpheuSupercede;
		}
		else
		{
			if(is_user_connected(gId)){
				static szTmp[256]
				copy(szTmp,charsmax(szTmp),szStr)
				static szName[64];
				get_user_name(gId,szName,charsmax(szName));
				replace_all(szTmp,charsmax(szTmp),"[you]",szName)
				OrpheuSetParam(1,szTmp)
			}
		}
	}
	return OrpheuIgnored;
}  

public OrpheuHookReturn:MessageBeginf(msg_dest,msg_type, const Float:pOrigin[],ed)
{
	catch = false;
	stop = false;
	iMessage = 0;
	Tmp = "";
	copied = false;
	if(msg_type == 76 || msg_type == 77 || msg_type == 23)
	{
		catch = true;
		gId = ed;
		if((!gId || msg_dest == MSG_ALL) && msg_type != 23){
			iMessage = msg_type;
			stop = true;
		}
	}
}  

public OrpheuHookReturn:MessageEndf(){
	gId = 0;
	if(stop){
		new szTmp[256]
		copy(szTmp,charsmax(szTmp),Tmp)
		Tmp = "";
		switch(iMessage){
			case 76:
			{
				static id;
				for(id = 1;id<=g_max_player;id++){
					if(!is_user_connected(id)){
						continue;
					}
					ShowMessageSayText(id,MSG_ONE,szTmp)
				}
			}
			case 77:
			{
				static id;
				for(id = 1;id<=g_max_player;id++){
					if(!is_user_connected(id)){
						continue;
					}
					ShowMessageTextMsg(id,MSG_ONE,szTmp)
				}
			}
		}
	}
	iMessage = 0;
	iDestType = 0;
	
}


stock ShowMessageSayText(id, type, message[])
{
	message_begin(type, 76, {0,0,0}, id);
	write_byte(id)		
	write_string(message);
	message_end();	
}

stock ShowMessageTextMsg(id,type,message[])
{
	message_begin(type, 77, {0,0,0}, id)
	write_byte(iDestType)
	write_string(message)
	message_end()
}
