#include <amxmodx>
#include <cstrike>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplague>
#include <colorchat>

#define VERSION "1.0"

new const sound[] = "cyberskillpl_zm/antilaser.wav"    //nie pisz folderu sound, bo lapie samo

// Item IDs
new g_laser, g_can[33], shots, reward_ap, laser, sync, g_shots[33]
new g_msgDeathMsg, g_msgScoreAttrib, g_msgScoreInfo
//new pointer[2]
new g_cost = 25
new SayText
new cvar_laser_frag, cvar_laser_ap

public plugin_init()
{
	/* Plugin Registery */
	register_plugin("[ZP] Antilaser", VERSION, "Geratius")
	
	register_forward(FM_PlayerPreThink, "fw_PlayerPreThink")
	
	register_cvar("zp_lasers", VERSION, FCVAR_SERVER)
	
	/* Language File */
	register_dictionary("zp_antilaser.txt")
	SayText = get_user_msgid("SayText")
	/* Cvars */
	g_laser = zp_register_extra_item("Antilaser", g_cost, ZP_TEAM_HUMAN)
	shots = register_cvar("zp_antilaser_shots", "3")
	reward_ap = register_cvar("zp_antilaser_reward", "2")
	sync = CreateHudSyncObj()
	g_msgDeathMsg = get_user_msgid("DeathMsg")
	g_msgScoreAttrib = get_user_msgid("ScoreAttrib")
	g_msgScoreInfo = get_user_msgid("ScoreInfo")
	
	cvar_laser_frag = register_cvar("zp_laser_frag","1")
	cvar_laser_ap = register_cvar("zp_laser_ap","1")
	//pointer[0] = get_cvar_pointer("zp_human_frags_for_kill")
	//pointer[1] = get_cvar_pointer("zp_antilaser_reward")
}

public plugin_precache()
{
	laser = precache_model("sprites/laserbeam.spr")
	precache_sound(sound)
}

public client_putinserver(id)
{
	g_can[id] = false
	g_shots[id] = false
}

public client_disconnect(id)
{
	g_can[id] = false
	g_shots[id] = false
}

// Item Selected forward
public zp_extra_item_selected(id, itemid)
{
	if (itemid == g_laser)
	{
		if(!zp_has_round_started())
		{
			ColorChat(id, GREEN, "^x04[ZM]^x01 Poczekaj na tryb rozgrywki...")
			new ileap = zp_get_user_ammo_packs(id)
			zp_set_user_ammo_packs(id, ileap + g_cost);
			return PLUGIN_HANDLED
		}
		if(zp_is_swarm_round() || zp_is_nemesis_round() || zp_is_plague_round())
		{
			ColorChat(id, GREEN, "^x04[ZM]^x01 Nie mozesz kupic tego itemu!")
			new ileap = zp_get_user_ammo_packs(id)
			zp_set_user_ammo_packs(id, ileap + g_cost);
			return PLUGIN_HANDLED
		}
		/*
		if(is_user_alive(id) && (zp_get_user_ammo_packs(id)< g_cost))
		{
			ColorChat(id, GREEN, "^x04[ZM]^x01 Nie stac Cie na kupno^x04 Apteczki^x01!")
			//client_print(player,print_chat,"[ZP] Nie stac Cie na kupno apteczki.")
			return PLUGIN_HANDLED
		}
		
		if(is_user_alive(id) && (zp_get_user_ammo_packs(id)>= g_cost))
		*/
		else
		{
			g_can[id] = true
			g_shots[id] = 0
			ColorChat(id, GREEN, "^x04[ZM]^x01 Kupiles^x04 Antilaser^x01! Za kazde uleczone Zombie otrzymasz^x04 %d ap^x01! Przyciskiem^x04 'E' ^x01uleczasz.", get_pcvar_num(reward_ap));
			//client_print(player, print_chat, "[ZP] Kupiles apteczke. Zeby jej uzyc, nacisnij LPM.")
		}
	}
	return PLUGIN_HANDLED
}

public zp_user_infected_pre(id, infector)
{
	g_can[id] = false
}

public fw_PlayerPreThink(id)
{
	if(g_can[id] && !zp_is_swarm_round() && !zp_is_nemesis_round() && !zp_is_plague_round())
	{
		if(pev(id, pev_button) & IN_USE)
		{
			if(!(pev(id, pev_oldbuttons) & IN_USE))
			{
				set_hudmessage(0, 128, 255, -1.0, 0.17, 1, 0.0, 3.0, 1.0, 1.0, -1)
				
				if (g_shots[id] >= get_pcvar_num(shots) || !is_user_alive(id))
				{
					//client_print(id, print_chat, "[ZP] %L", id, "CANNOT")
					ColorChat(id, GREEN, "^x04[ZM]^x01 Skonczyly Ci sie strzaly!")
					g_can[id] = false
					return FMRES_IGNORED
				}
					
				new ofin[3], name[32]
				get_user_origin(id, ofin, 3)
				efecto(id, ofin) 
				
				new target, temp, name2[32]
				get_user_aiming(id, target, temp, 9999)
				get_user_name(id, name, sizeof name - 1)
				get_user_name(target, name2, sizeof name2 - 1)
				
				//client_print(id, print_center, "[ZP] %L", id, "BOUGHT")
				//client_print(id, print_center, "Kupiles Antilaser. Aby uleczyc zombie, wyceluj w nie i nacisnij 'E'.")
				
				if(zp_get_user_first_zombie(target))
				{
					//client_print(id, print_chat, "[ZP] %L", id, "FIRST")
					ColorChat(id, GREEN, "^x04[ZM]^x01 Nie mozesz uleczyc pierwszego zombie!")
					//client_print(id, print_center, "Nie mozesz uleczyc pierwszego zombie.")
					
					g_shots[id]++
					ShowSyncHudMsg(id, sync, "%L", id, "SHOTS_LEFT", g_shots[id], get_pcvar_num(shots))
					return FMRES_IGNORED
				}

				
				if (is_user_alive(target) && zp_get_user_zombie(target) && !zp_get_user_first_zombie(target) && !zp_get_user_last_zombie(target) && !zp_get_user_nemesis(target))
				{	
					/* zombie plague */
					SendDeathMsg(id, target) // send death notice
					FixDeadAttrib(target) // fix the "dead" attrib on scoreboard
					UpdateFrags(id, target, get_pcvar_num(cvar_laser_frag), 1, 1) // add corresponding frags & deaths
					/* zombie plague */
					desinfectar(target)
					zp_disinfect_user(target)
					new ammo = zp_get_user_ammo_packs(id)
					zp_set_user_ammo_packs(id, ammo + get_pcvar_num(cvar_laser_ap))
					client_printcolor(id, "/g[ZM] /yOtrzymales/g %d ap /yza uleczenie Zombie/g %s /yAntilaserem", get_pcvar_num(reward_ap), name2)
					//client_print(0, print_chat, "[ZP] %L", id, "DISINFECT", name, name2)
				}
				
				g_shots[id]++
				
				ShowSyncHudMsg(id, sync, "%L", id, "SHOTS_LEFT", g_shots[id], get_pcvar_num(shots))
			}
		}
	}
	
	return FMRES_IGNORED
}

public efecto(id, ofin[3])
{
	engfunc(EngFunc_EmitSound, id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	new origin[3]
	get_user_origin(id, origin, 1)
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(27)
	write_coord(origin[0]) // x
	write_coord(origin[1]) // y
	write_coord(origin[2]) // z
	write_byte(40) 
	write_byte(0) // r
	write_byte(128) // g
	write_byte(255) // b
	write_byte(100)
	write_byte(10)
	write_byte(1)
	message_end()

	message_begin(MSG_PVS, SVC_TEMPENTITY)
	write_byte(0)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(ofin[0])
	write_coord(ofin[1])
	write_coord(ofin[2])
	write_short(laser) 
	write_byte(5)
	write_byte(5)
	write_byte(3)
	write_byte(25)
	write_byte(5)
	write_byte(0)
	write_byte(128)
	write_byte(255)
	write_byte(100)
	write_byte(200)
	message_end()
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(14)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(240)
	write_byte(120)
	write_byte(5) 
	message_end()
}

public desinfectar(target)
{
	new origin[3]
	get_user_origin(target, origin, 1)
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(14)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(240)
	write_byte(120)
	write_byte(5) 
	message_end()
}

// zombie plague
SendDeathMsg(attacker, victim)
{
	message_begin(MSG_BROADCAST, g_msgDeathMsg)
	write_byte(attacker) // killer
	write_byte(victim) // victim
	write_byte(1) // headshot flag
	write_string("antidote laser") // killer's weapon
	message_end()
}

FixDeadAttrib(id)
{
	message_begin(MSG_BROADCAST, g_msgScoreAttrib)
	write_byte(id) // id
	write_byte(0) // attrib
	message_end()
}

UpdateFrags(attacker, victim, frags, deaths, scoreboard)
{
	// Set attacker frags
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) + frags))
	
	// Set victim deaths
	cs_set_user_deaths(victim, cs_get_user_deaths(victim) + deaths)
	
	// Update scoreboard with attacker and victim info
	if (scoreboard)
	{
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(attacker) // id
		write_short(pev(attacker, pev_frags)) // frags
		write_short(cs_get_user_deaths(attacker)) // deaths
		write_short(0) // class?
		write_short(get_user_team(attacker)) // team
		message_end()
		
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(victim) // id
		write_short(pev(victim, pev_frags)) // frags
		write_short(cs_get_user_deaths(victim)) // deaths
		write_short(0) // class?
		write_short(get_user_team(victim)) // team
		message_end()
	}
}

stock client_printcolor(const id, const input[], any:...)
{
	new iCount = 1, iPlayers[32]
	
	static szMsg[191]
	vformat(szMsg, charsmax(szMsg), input, 3)
	
	replace_all(szMsg, 190, "/g", "^4") // green txt
	replace_all(szMsg, 190, "/y", "^1") // orange txt
	replace_all(szMsg, 190, "/ctr", "^3") // team txt
	replace_all(szMsg, 190, "/w", "^0") // team txt
	
	if(id) iPlayers[0] = id
	else get_players(iPlayers, iCount, "ch")
		
	for (new i = 0; i < iCount; i++)
	{
		if (is_user_connected(iPlayers[i]))
		{
			message_begin(MSG_ONE_UNRELIABLE, SayText, _, iPlayers[i])
			write_byte(iPlayers[i])
			write_string(szMsg)
			message_end()
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
